;
; AutoHotkey Version: 1.x
; Language:       English
; Platform:       Win9x/NT
; Author:         r0lZ
;
; Script Function:
;	Patches C:\Tcl\work\PGCEDIT\freeWrap.exe's Version Information resource with the rigth version
;

reswintitle = Resource Hacker  -  

#NoEnv ; Recommended for performance and compatibility with future AutoHotkey releases.
SendMode Input ; Recommended for new scripts due to its superior speed and reliability.

; parse command line
if 0 != 1
{
	MsgBox Usage: PatchFreeWrap.ahk PgcEdit_version_number`nExample: PatchFreeWrap.ahk 8.5beta1
	ExitApp 1
}
verstring = %1%
;verstring = 8.4beta5

; build right version strings for ResHack
verstring1 := verstring
ifInString verstring, beta
{
	StringGetPos, pos, verstring, beta
	pos2 := pos + 5
	beta := SubStr(verstring, pos2)
	verstring := SubStr(verstring, 1, pos)
} else {
	beta = 1000
}
verstring2 =
numnumbers = 3
Loop parse, verstring, .
{
	verstring2 = %verstring2%%A_LoopField%`,
	numnumbers -= 1
}
Loop %numnumbers%
{
	verstring2 = %verstring2%0`,
}
verstring2 = %verstring2%%beta%

; sanity check: ensure that Resource Hacker is not currently running
ifWinExist %reswintitle%
{
	MsgBox Please close all instances of Resource Hacker`nbefore launching PatchFreeWrap!
	ExitApp 1
}

; Open ResHack and load freewrap.exe
run "C:\Program Files\Resource Hacker\ResHacker.exe" "C:\Tcl\work\PGCEDIT\freewrap.exe"
winWait %reswintitle%
sleep 100

; Open right resource in right pane
; Potential bug here: assumes fixed number and order of resources!
send {down 6}
send {right 4}
;exitapp

; Get Version Information resource
controlGetText rctext, TRichEdit1, %reswintitle%
IfNotInString rctext, BLOCK "StringFileInfo"
{
	msgbox Something went wrong: Wrong resource selected!
	exitApp 1
}

; Build modified Version Information resource
output =
quotes = "
quotes = "
Loop parse, rctext, `n, `r
{
	str := A_LoopField
	ifInString str, FILEVERSION
	{
		ifNotInString str, VALUE
			str = FILEVERSION %verstring2%
		else
			str := "`t`tVALUE " quotes "FileVersion" quotes ", " quotes verstring1 quotes " "
	}
	ifInString str, PRODUCTVERSION
	{
		ifNotInString str, VALUE
			str = PRODUCTVERSION %verstring2%
		else
			str := "`t`tVALUE " quotes "ProductVersion" quotes ", " quotes verstring1 quotes " "
	}
	output = %output%%str%`n
}

; Replace Version Information resource
ControlSetText TRichEdit1, %output%, %reswintitle%

; Compile new resource
sleep 100
ControlClick TButton1, %reswintitle%

; Save freewrap.exe
sleep 500
ControlSend ahk_parent, ^s, %reswintitle%

; Close ResHack and exit
sleep 500
WinClose %reswintitle%
exitApp 0
